<template>
    <v-row>
        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">
                    <h1 class="pb-8">Création d'un client</h1>
                    <CreateForm :data="form"/>
                    <v-btn @click="createClient()" color="primary" size="large" flat>Créer le client</v-btn>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<script lang="ts">
    import CreateForm from '~/components/crud/CreateForm.vue';
    import { ref } from 'vue';

    export default {
        components: {
            CreateForm
        },
        async setup() {
            const form = ref({
                nom: {
                    formType: 'text',
                    label: 'Nom du client',
                    value: '',
                    rules: 'required|string',
                    colLenght: 12
                },
                adresse : {
                    formType: 'text',
                    label: 'Adresse du client',
                    value: '',
                    rules: 'required|string',
                    colLenght: 12,
                },
                email : {
                    formType: 'text',
                    label: 'Email du client',
                    value: '',
                    rules: 'required|string',
                    colLenght: 7
                },
                telephone : {
                    formType: 'text',
                    label: 'Téléphone du client',
                    value: '',
                    rules: 'required|string',
                    colLenght: 5
                }
            });

            const createClient = async () => {
                const responseDetailClient = await fetch('http://localhost:8000/api/clients', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/ld+json',
                    },
                    body: JSON.stringify({
                        nom: form.value.nom.value,
                        adresse: form.value.adresse.value,
                        email: form.value.email.value,
                        telephone: form.value.telephone.value,
                        devis: [],
                        factures: []
                    })
                });
                navigateTo('/clients/list');
            }

            return {
                form,
                createClient
            }
        }
    }
</script>